# coding: utf-8

"""
    NiFi Rest API

    The Rest API provides programmatic access to command and control a NiFi instance in real time. Start and                                             stop processors, monitor queues, query provenance data, and more. Each endpoint below includes a description,                                             definitions of the expected input and output, potential response codes, and the authorizations required                                             to invoke each service.

    OpenAPI spec version: 1.23.2
    Contact: dev@nifi.apache.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ParameterProviderParameterApplicationEntity(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'revision': 'RevisionDTO',
        'disconnected_node_acknowledged': 'bool',
        'parameter_group_configurations': 'list[ParameterGroupConfigurationEntity]'
    }

    attribute_map = {
        'id': 'id',
        'revision': 'revision',
        'disconnected_node_acknowledged': 'disconnectedNodeAcknowledged',
        'parameter_group_configurations': 'parameterGroupConfigurations'
    }

    def __init__(self, id=None, revision=None, disconnected_node_acknowledged=None, parameter_group_configurations=None):
        """
        ParameterProviderParameterApplicationEntity - a model defined in Swagger
        """

        self._id = None
        self._revision = None
        self._disconnected_node_acknowledged = None
        self._parameter_group_configurations = None

        if id is not None:
          self.id = id
        if revision is not None:
          self.revision = revision
        if disconnected_node_acknowledged is not None:
          self.disconnected_node_acknowledged = disconnected_node_acknowledged
        if parameter_group_configurations is not None:
          self.parameter_group_configurations = parameter_group_configurations

    @property
    def id(self):
        """
        Gets the id of this ParameterProviderParameterApplicationEntity.
        The id of the parameter provider.

        :return: The id of this ParameterProviderParameterApplicationEntity.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ParameterProviderParameterApplicationEntity.
        The id of the parameter provider.

        :param id: The id of this ParameterProviderParameterApplicationEntity.
        :type: str
        """

        self._id = id

    @property
    def revision(self):
        """
        Gets the revision of this ParameterProviderParameterApplicationEntity.
        The revision for this request/response. The revision is required for any mutable flow requests and is included in all responses.

        :return: The revision of this ParameterProviderParameterApplicationEntity.
        :rtype: RevisionDTO
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """
        Sets the revision of this ParameterProviderParameterApplicationEntity.
        The revision for this request/response. The revision is required for any mutable flow requests and is included in all responses.

        :param revision: The revision of this ParameterProviderParameterApplicationEntity.
        :type: RevisionDTO
        """

        self._revision = revision

    @property
    def disconnected_node_acknowledged(self):
        """
        Gets the disconnected_node_acknowledged of this ParameterProviderParameterApplicationEntity.
        Acknowledges that this node is disconnected to allow for mutable requests to proceed.

        :return: The disconnected_node_acknowledged of this ParameterProviderParameterApplicationEntity.
        :rtype: bool
        """
        return self._disconnected_node_acknowledged

    @disconnected_node_acknowledged.setter
    def disconnected_node_acknowledged(self, disconnected_node_acknowledged):
        """
        Sets the disconnected_node_acknowledged of this ParameterProviderParameterApplicationEntity.
        Acknowledges that this node is disconnected to allow for mutable requests to proceed.

        :param disconnected_node_acknowledged: The disconnected_node_acknowledged of this ParameterProviderParameterApplicationEntity.
        :type: bool
        """

        self._disconnected_node_acknowledged = disconnected_node_acknowledged

    @property
    def parameter_group_configurations(self):
        """
        Gets the parameter_group_configurations of this ParameterProviderParameterApplicationEntity.
        Configuration for the fetched Parameter Groups

        :return: The parameter_group_configurations of this ParameterProviderParameterApplicationEntity.
        :rtype: list[ParameterGroupConfigurationEntity]
        """
        return self._parameter_group_configurations

    @parameter_group_configurations.setter
    def parameter_group_configurations(self, parameter_group_configurations):
        """
        Sets the parameter_group_configurations of this ParameterProviderParameterApplicationEntity.
        Configuration for the fetched Parameter Groups

        :param parameter_group_configurations: The parameter_group_configurations of this ParameterProviderParameterApplicationEntity.
        :type: list[ParameterGroupConfigurationEntity]
        """

        self._parameter_group_configurations = parameter_group_configurations

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ParameterProviderParameterApplicationEntity):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
