# coding: utf-8

"""
    NiFi Rest API

    The Rest API provides programmatic access to command and control a NiFi instance in real time. Start and                                             stop processors, monitor queues, query provenance data, and more. Each endpoint below includes a description,                                             definitions of the expected input and output, potential response codes, and the authorizations required                                             to invoke each service.

    OpenAPI spec version: 1.23.2
    Contact: dev@nifi.apache.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ParameterStatusDTO(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'parameter': 'ParameterEntity',
        'status': 'str'
    }

    attribute_map = {
        'parameter': 'parameter',
        'status': 'status'
    }

    def __init__(self, parameter=None, status=None):
        """
        ParameterStatusDTO - a model defined in Swagger
        """

        self._parameter = None
        self._status = None

        if parameter is not None:
          self.parameter = parameter
        if status is not None:
          self.status = status

    @property
    def parameter(self):
        """
        Gets the parameter of this ParameterStatusDTO.
        The name of the Parameter

        :return: The parameter of this ParameterStatusDTO.
        :rtype: ParameterEntity
        """
        return self._parameter

    @parameter.setter
    def parameter(self, parameter):
        """
        Sets the parameter of this ParameterStatusDTO.
        The name of the Parameter

        :param parameter: The parameter of this ParameterStatusDTO.
        :type: ParameterEntity
        """

        self._parameter = parameter

    @property
    def status(self):
        """
        Gets the status of this ParameterStatusDTO.
        Indicates the status of the parameter, compared to the existing parameter context

        :return: The status of this ParameterStatusDTO.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ParameterStatusDTO.
        Indicates the status of the parameter, compared to the existing parameter context

        :param status: The status of this ParameterStatusDTO.
        :type: str
        """
        allowed_values = ["NEW", "CHANGED", "REMOVED", "MISSING_BUT_REFERENCED", "UNCHANGED"]
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ParameterStatusDTO):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
