# coding: utf-8

"""
    NiFi Rest API

    The Rest API provides programmatic access to command and control a NiFi instance in real time. Start and                                             stop processors, monitor queues, query provenance data, and more. Each endpoint below includes a description,                                             definitions of the expected input and output, potential response codes, and the authorizations required                                             to invoke each service.

    OpenAPI spec version: 1.23.2
    Contact: dev@nifi.apache.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RegisteredFlow(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'identifier': 'str',
        'name': 'str',
        'description': 'str',
        'bucket_identifier': 'str',
        'bucket_name': 'str',
        'created_timestamp': 'int',
        'last_modified_timestamp': 'int',
        'permissions': 'FlowRegistryPermissions',
        'version_count': 'int',
        'version_info': 'RegisteredFlowVersionInfo'
    }

    attribute_map = {
        'identifier': 'identifier',
        'name': 'name',
        'description': 'description',
        'bucket_identifier': 'bucketIdentifier',
        'bucket_name': 'bucketName',
        'created_timestamp': 'createdTimestamp',
        'last_modified_timestamp': 'lastModifiedTimestamp',
        'permissions': 'permissions',
        'version_count': 'versionCount',
        'version_info': 'versionInfo'
    }

    def __init__(self, identifier=None, name=None, description=None, bucket_identifier=None, bucket_name=None, created_timestamp=None, last_modified_timestamp=None, permissions=None, version_count=None, version_info=None):
        """
        RegisteredFlow - a model defined in Swagger
        """

        self._identifier = None
        self._name = None
        self._description = None
        self._bucket_identifier = None
        self._bucket_name = None
        self._created_timestamp = None
        self._last_modified_timestamp = None
        self._permissions = None
        self._version_count = None
        self._version_info = None

        if identifier is not None:
          self.identifier = identifier
        if name is not None:
          self.name = name
        if description is not None:
          self.description = description
        if bucket_identifier is not None:
          self.bucket_identifier = bucket_identifier
        if bucket_name is not None:
          self.bucket_name = bucket_name
        if created_timestamp is not None:
          self.created_timestamp = created_timestamp
        if last_modified_timestamp is not None:
          self.last_modified_timestamp = last_modified_timestamp
        if permissions is not None:
          self.permissions = permissions
        if version_count is not None:
          self.version_count = version_count
        if version_info is not None:
          self.version_info = version_info

    @property
    def identifier(self):
        """
        Gets the identifier of this RegisteredFlow.

        :return: The identifier of this RegisteredFlow.
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """
        Sets the identifier of this RegisteredFlow.

        :param identifier: The identifier of this RegisteredFlow.
        :type: str
        """

        self._identifier = identifier

    @property
    def name(self):
        """
        Gets the name of this RegisteredFlow.

        :return: The name of this RegisteredFlow.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this RegisteredFlow.

        :param name: The name of this RegisteredFlow.
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """
        Gets the description of this RegisteredFlow.

        :return: The description of this RegisteredFlow.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this RegisteredFlow.

        :param description: The description of this RegisteredFlow.
        :type: str
        """

        self._description = description

    @property
    def bucket_identifier(self):
        """
        Gets the bucket_identifier of this RegisteredFlow.

        :return: The bucket_identifier of this RegisteredFlow.
        :rtype: str
        """
        return self._bucket_identifier

    @bucket_identifier.setter
    def bucket_identifier(self, bucket_identifier):
        """
        Sets the bucket_identifier of this RegisteredFlow.

        :param bucket_identifier: The bucket_identifier of this RegisteredFlow.
        :type: str
        """

        self._bucket_identifier = bucket_identifier

    @property
    def bucket_name(self):
        """
        Gets the bucket_name of this RegisteredFlow.

        :return: The bucket_name of this RegisteredFlow.
        :rtype: str
        """
        return self._bucket_name

    @bucket_name.setter
    def bucket_name(self, bucket_name):
        """
        Sets the bucket_name of this RegisteredFlow.

        :param bucket_name: The bucket_name of this RegisteredFlow.
        :type: str
        """

        self._bucket_name = bucket_name

    @property
    def created_timestamp(self):
        """
        Gets the created_timestamp of this RegisteredFlow.

        :return: The created_timestamp of this RegisteredFlow.
        :rtype: int
        """
        return self._created_timestamp

    @created_timestamp.setter
    def created_timestamp(self, created_timestamp):
        """
        Sets the created_timestamp of this RegisteredFlow.

        :param created_timestamp: The created_timestamp of this RegisteredFlow.
        :type: int
        """

        self._created_timestamp = created_timestamp

    @property
    def last_modified_timestamp(self):
        """
        Gets the last_modified_timestamp of this RegisteredFlow.

        :return: The last_modified_timestamp of this RegisteredFlow.
        :rtype: int
        """
        return self._last_modified_timestamp

    @last_modified_timestamp.setter
    def last_modified_timestamp(self, last_modified_timestamp):
        """
        Sets the last_modified_timestamp of this RegisteredFlow.

        :param last_modified_timestamp: The last_modified_timestamp of this RegisteredFlow.
        :type: int
        """

        self._last_modified_timestamp = last_modified_timestamp

    @property
    def permissions(self):
        """
        Gets the permissions of this RegisteredFlow.

        :return: The permissions of this RegisteredFlow.
        :rtype: FlowRegistryPermissions
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """
        Sets the permissions of this RegisteredFlow.

        :param permissions: The permissions of this RegisteredFlow.
        :type: FlowRegistryPermissions
        """

        self._permissions = permissions

    @property
    def version_count(self):
        """
        Gets the version_count of this RegisteredFlow.

        :return: The version_count of this RegisteredFlow.
        :rtype: int
        """
        return self._version_count

    @version_count.setter
    def version_count(self, version_count):
        """
        Sets the version_count of this RegisteredFlow.

        :param version_count: The version_count of this RegisteredFlow.
        :type: int
        """

        self._version_count = version_count

    @property
    def version_info(self):
        """
        Gets the version_info of this RegisteredFlow.

        :return: The version_info of this RegisteredFlow.
        :rtype: RegisteredFlowVersionInfo
        """
        return self._version_info

    @version_info.setter
    def version_info(self, version_info):
        """
        Sets the version_info of this RegisteredFlow.

        :param version_info: The version_info of this RegisteredFlow.
        :type: RegisteredFlowVersionInfo
        """

        self._version_info = version_info

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RegisteredFlow):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
