# coding: utf-8

"""
    NiFi Rest API

    The Rest API provides programmatic access to command and control a NiFi instance in real time. Start and                                             stop processors, monitor queues, query provenance data, and more. Each endpoint below includes a description,                                             definitions of the expected input and output, potential response codes, and the authorizations required                                             to invoke each service.

    OpenAPI spec version: 1.23.2
    Contact: dev@nifi.apache.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RunStatusDetailsRequestEntity(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'processor_ids': 'list[str]'
    }

    attribute_map = {
        'processor_ids': 'processorIds'
    }

    def __init__(self, processor_ids=None):
        """
        RunStatusDetailsRequestEntity - a model defined in Swagger
        """

        self._processor_ids = None

        if processor_ids is not None:
          self.processor_ids = processor_ids

    @property
    def processor_ids(self):
        """
        Gets the processor_ids of this RunStatusDetailsRequestEntity.
        The IDs of all processors whose run status details should be provided

        :return: The processor_ids of this RunStatusDetailsRequestEntity.
        :rtype: list[str]
        """
        return self._processor_ids

    @processor_ids.setter
    def processor_ids(self, processor_ids):
        """
        Sets the processor_ids of this RunStatusDetailsRequestEntity.
        The IDs of all processors whose run status details should be provided

        :param processor_ids: The processor_ids of this RunStatusDetailsRequestEntity.
        :type: list[str]
        """

        self._processor_ids = processor_ids

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RunStatusDetailsRequestEntity):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
