# coding: utf-8

"""
    Apache NiFi Registry REST API

    The REST API provides an interface to a registry with operations for saving, versioning, reading NiFi flows and components.

    OpenAPI spec version: 1.23.2
    Contact: dev@nifi.apache.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RegistryAbout(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'registry_about_version': 'str'
    }

    attribute_map = {
        'registry_about_version': 'registryAboutVersion'
    }

    def __init__(self, registry_about_version=None):
        """
        RegistryAbout - a model defined in Swagger
        """

        self._registry_about_version = None

        if registry_about_version is not None:
          self.registry_about_version = registry_about_version

    @property
    def registry_about_version(self):
        """
        Gets the registry_about_version of this RegistryAbout.
        The version string for this Nifi Registry

        :return: The registry_about_version of this RegistryAbout.
        :rtype: str
        """
        return self._registry_about_version

    @registry_about_version.setter
    def registry_about_version(self, registry_about_version):
        """
        Sets the registry_about_version of this RegistryAbout.
        The version string for this Nifi Registry

        :param registry_about_version: The registry_about_version of this RegistryAbout.
        :type: str
        """

        self._registry_about_version = registry_about_version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RegistryAbout):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
